Subject: RE: MPLS over OTN

From: "Howard Green" <[email-masked]>
Date: Mon, 4 Aug 2008 10:23:54 +0200

Adrian
Thanks (for the homily as well!)
My apologies for some lack of clarity.
As you say, GMPLS control of OTN is what it is. The use of a G-PID
describing an MPLS payload does, presumably, allow an OTN path to be
advertised (with suitable policy constraints) as an MPLS forwarding
adjacency. In the MPLS layer above this OTN, it is not so obvious how to
carry IP "in band", and therefore the GMPLS mechanics seem to be
required. As you say, the control plane could be "OOB but in fiber" (or
here, in OTN path) or out of fibre. Thus there would seem to be utility
in an optional associated channel mechanism for the control plane. I
wonder whether there may be a requirement of the reverse kind (maximum
diversity between data plane and control plane) in some circumstances.
/Howard

> -----Original Message-----
> From: Adrian Farrel [mailto:[email-masked]] 
> Sent: 01 August 2008 10:53
> To: Howard Green; [email-masked]
> Cc: [email-masked]
> Subject: Re: MPLS over OTN
> 
> Hi Howard,
> 
> [adding MPLS-TP mailing list]
> 
> Accurate representation of our conversation.
> That is, in GMPLS we have label type, switching type, 
> encoding type, and G-PID.
> G-PID identifies the payload and re-uses the Ethertype 
> codepoints. Thus we can carry MPLS.
> If GFP is used for framing, it must also identify the payload 
> and, as you point out, GFP has an MPLS codepoint.
> 
> That the GFP codepoint for MPLS is the same as that for 
> "T-MPLS" is good for Option 1 (which is where we are) since 
> there is no practical difference between MPLS and MPLS-TP.
> 
> Now, the operation of MPLS over OTN that you describe is 
> actually the operation of an OTN. So the issues of control 
> channels in OTN are exactly as you describe, but have nothing 
> to do with the payload protocol. This is simply GMPLS control 
> of OTN. Period.
> 
> GMPLS control of MPLS-TP is a different kettle of ball games. 
> Here the switching type is PSC: the same switching type as 
> for MPLS. A feature of GMPLS is that there is *logical* 
> separation of control plane and data plane. 
> This means that the control plane can be in-band (MPLS-TE), 
> out-of-band but in-fibre (SONET/SDH or OSC), or out-of-fibre.
> 
> MPLS-TP requirements say that it must be possible to operate 
> the network "in the absence of IP." I have taken this to mean 
> "in the absence of IP routing and forwarding" (but this is my 
> opinion and there is no explicit evidence in the requirements 
> I-D). With this view...
> - We can use IP identifiers (addresses) in the data plane and 
> the control plane
> - We can use IP-based control protocols (GMPLS)
> - We can use an IP-based control network if available, but we cannot
>    mandate it
> - Control entities that need to communicate must be allowed to be
>    IP-adjacent so that there is no requirement for 
> IP-forwarding in the
>    network
> 
> I believe we can do all of the above, and often do in GMPLS networks.
> The crunch questions are:
> 1. What is the physical technology for the data links in the 
> control plane?
> 2. How do we identify control plane traffic when it arrives at a node?
> 3. How do we exchange control plane messages between nodes that
>    do not have a common data link in the control plane?
> 
> Answers are:
> 1. We don't care :-)
>     But a possible answer in MPLS-TP is an LSP (e.g. a 
> reserved label) 2. From the data link (since there is no need 
> to disambiguate the control
>    plane traffic from any other traffic on the data link) 3. 
> This is a more tricky question. However nearly all of the messages
>    are exchanged only between data-plane-adjacent nodes. This can be
>    the case in the IGP-TE protocols, and is true for all messages in
>    RSVP-TE with a couple of exceptions (below). It is also 
> the case for
>    LMP. So IP forwarding is not required in the control plane.
>    The tricky cases are:
>    - echo response in LSP Ping (we are rebuilding the OAM)
>    - Notify message in RSVP-TE (we are considering OAM approaches
>      for the uses of Notify where IP forwarding is not available)
>    - "Targeted Path messages" used in hierarchical LSPs (and LSP
>       stitching). In these cases we are effectively building a virtual
>       data plane adjacency and should build a parallel virtual control
>       plane link between the end points (e.g. an LSP).
> 
> We should note that the output of the JWT *appears* to be 
> that "GMPLS meets the requirements of a control plane for MPLS-TP."
> 
> We should also note that management plane operation of 
> MPLS-TP is a requirement, and we must assume that management 
> plane messages may need to be exchanged between management 
> stations and network nodes using some protocol and connectivity.
> 
> </homily>
> 
> Adrian
> ----- Original Message -----
> From: "Howard Green" <[email-masked]>
> To: <[email-masked]>
> Sent: Thursday, July 31, 2008 5:55 PM
> Subject: MPLS over OTN
> 
> 
> Just to record for the list a chat with Adrian and Lou Berger. I
> discover from reading G.7041 Amendment 2 that there is a codepoint
> defined to allow unicast MPLS frames to be carried over OTN (ODUx)
> channels by way of GFP encoding. Reading RFC 4328, there is 
> an encoding
> type for ODUx, and the switching type is TDM. There is no 
> specific G-PID
> value defined for the MPLS codepoint (which was probably defined
> concurrently with the writing of RFC 4328). Adrian and Lou 
> took the view
> that in this situation, the use of the unicast MPLS ethertype (#8847)
> would define for signalling this bearer type (as described in 
> RFC 3471).
> 
> This is relevant partly because G.7041 amendment 2 defines 
> the codepoint
> to be for "MPLS or T-MPLS". I assume that this usage carries over to
> MPLS-TP. In this situation,interestingly, there is no 
> prospect of inband
> IP control, and so GMPLS is the only control plane option.
> Is this correct?
> Regards Howard
> 
> 
> 
>

---

From: "Adrian Farrel" <[email-masked]>
Date: Mon, 4 Aug 2008 09:42:53 +0100

Hi again Howard,

So, to pick apart the control plane in an MPLS network ( I think I am 
agreeing with you fully)...

In band
This could only happen using the sort of mechanisms being proposed for ACH.
That is, each control plane message is packaged as an MPLS packet and 
labelled as for the LSP that it is controlling. The TTL is set to one (or 
more to allow non-adjacent signalling). A secondary label on the stack might 
be used to identify the control plane when the top-level label expires. We 
already have the Router Alert label defined.
However, such a mechanism would only work for existing LSPs meaning that we 
could never set up new ones!

Out of band in fibre
(Bear in mind that the nature of MPLS means that this is very similar to in 
band except within the switching fabric)
To make this work we simply need a reserved label to identify control plane 
traffic. The Router Alert label already provides this.
However, we lack a mechanism for non-adjacent signalling. There are two use 
cases in GMPLS...
1. Hierarchical and stitched LSPs
  In this case, we can use the hierarchical or stitched LSP to carry
  the control traffic. For hierarchical, it is simple since we can put the
  Router Alert label second on the stack where it will be discovered
  when the top label is popped. For stitching, we must also set the
  TTL to expire at the end of the stitching segment.
2. Notify messages
  These messages may be exchanged between non-adjacent nodes.
  Normally they rely on IP routing, but there is an option to get them
  forwarded hop-by-hop by the control planes of the nodes along the
  LSP - this is NOT IP-based forwarding, but relies on each node on
  the path of an LSP knowing the next control plane node in each
  direction (something that is required by RSVP-TE anyway).
  An alternative is to use the LSP that is being notified, and to set the
  TTL as necessary also using a Router Alert label just as for stitching.
A further alternative (sufficient but not necessary) approach would be to 
set up a mesh of LSPs to support the control plane.

Out of band out of fibre
I am inclined to agree that there may often be good reasons to operate this 
way.
Using an IP network as a DCN makes a lot of sense and it should be noted 
that this does not require that the NEs have IP forwarding capabilities.

Cheers,
Adrian

----- Original Message ----- 
From: "Howard Green" <[email-masked]>
To: "Adrian Farrel" <[email-masked]>; <[email-masked]>
Cc: <[email-masked]>
Sent: Monday, August 04, 2008 9:23 AM
Subject: RE: MPLS over OTN

Adrian